import '../libs/system.0.20.19'
import '../libs/es6-promise.auto.min'
import * as singleSpa from './single/single-spa';
import { GlobalEventDistributor } from './GlobalEventDistributor'
const globalEventDistributor = new GlobalEventDistributor();
import { hashPrefix, pathPrefix } from './Path'
// Register.js
// 在原来registerApp上做了一些删减,大概的原理是一模一样的
export function registerLocal({ base, main, prefix, store, name = 'local' }) {
    // 导入store模块
    let storeModule = {}, customProps = { globalEventDistributor: globalEventDistributor };

    storeModule = store && { storeInstance: null };

    // 注册应用于事件派发器
    if (storeModule.storeInstance && globalEventDistributor) {
        // 取出 redux storeInstance
        customProps.store = storeModule.storeInstance;
        // 注册到全局
        globalEventDistributor.registerStore(storeModule.storeInstance);
    }

    singleSpa.registerApplication(name, async () => main, base ? (() => true) : hashPrefix({ prefix }), customProps);
}


// 原来的registerApp方法,与以前一模一样,没有改动.
// 为了方便对比registerLocal,所以列出来 供大家参考
export async function registerApp(params) {
    // 导入store模块
    let storeModule = {};
    let customProps = { globalEventDistributor: globalEventDistributor };

    // 尝试导入store
    try {
        // storeModule = params.store ? await window.SystemJS.import(params.store) : { storeInstance: null };
        storeModule = { storeInstance: null };
    } catch (e) {
        console.log(`Could not load store of app ${params.name}.`, e);
        //如果失败则不注册该模块
        return
    }
    // 注册应用于事件派发器
    if (storeModule.storeInstance && globalEventDistributor) {
        // 取出 redux storeInstance
        customProps.store = storeModule.storeInstance;

        // 注册到全局
        globalEventDistributor.registerStore(storeModule.storeInstance);
    }
    console.log(params);
    
    singleSpa.registerApplication(params.name, 
        async () => {
           const a =  await window.SystemJS.import(params.main)
           console.log(a);
           
           return a
        }, params.base ? (() => true) : (params.useHashPath ? hashPrefix(params) : pathPrefix(params)), customProps);

}