const chokidar = require('chokidar');
const fs = require('fs');
const fse = require('fs-extra');
const process = require('process')
const CWD_FILE_PATH = process.cwd()
console.log('--- 开启自动配置 ---')

const GEN_FILE_NAME = 'apps.config.js'
const GEN_CONFIG_KEY_NAME = 'apps'
const FILE_NAME = 'app.json'

//监听文件变化
let temp_config
chokidar.watch(CWD_FILE_PATH, {
    ignored: /(^|[\/\\])\..|.git|apps.config.js|node_modules/,
    awaitWriteFinish: {
        pollInterval: 20000
    }
}).on('all', (event, path) => {
    console.log(event, path);
    let config = generateConfig(CWD_FILE_PATH, [])
    if (JSON.stringify(config) === JSON.stringify(temp_config)) return;
    fs.writeFileSync(`${CWD_FILE_PATH}/${GEN_FILE_NAME}`, `module.exports={${GEN_CONFIG_KEY_NAME}: ${JSON.stringify(config)}}`, {
        encoding: 'utf-8'
    });
    console.log(JSON.stringify(temp_config))
    temp_config = config
    console.log('配置文件已经重新生成', config)
});

// 生成配置文件
function generateConfig(path, config) {
    var files = fs.readdirSync(path);
    files.forEach(file => {
        var stat = fs.statSync(`${path}/${file}`);
        if (stat.isDirectory()) {
            //递归读取文件
            let json = fse.readJsonSync(`${path}/${file}/${FILE_NAME}`, { throws: false });// path + '/' + element + ` / ${ FILE_NAME }`
            if (json) { config.push(json); }
        }
    })
    return config;
}