"use strict";

import * as SPA from './single/single-spa';
import { registerApp, registerLocal } from './Register'

export async function bootstrap(mode, todoApp) {
    // 通过webpack代理到线上测试环境 拿到项目配置文件
    const appConfig = await window.SystemJS.import('/apps.config.js')
    console.log(appConfig);

    let { apps } = appConfig;

    if (mode === 'development' && todoApp) {
        // const res = await window.fetch('/app.json')
        // const c_app = await res.json()
        // 移除当前项目
        apps = apps.filter(_ => _.name !== todoApp.name)
    }

    // 注册
    for (let index = 0; index < apps.length; index++) {
        const app = apps[index];
        console.log(app);
        await registerApp({
            name: app.name,
            base: app.base,
            useHashPath: app.useHashPath,
            path: app.path,
            main: app.main,
            store: app.store,
            url: app.preFilePath,
            filePatterns: app.filePatterns,
        });
    }
    // 注册本地正在开发的模块
    todoApp && registerLocal(todoApp)
    SPA.start();
}

// console.log(process.env);

// if (process.env.NODE_ENV === 'development') {
bootstrap()
// }