const path = require('path');
const webpack = require('webpack');
const CleanWebpackPlugin = require('clean-webpack-plugin');
const ContextReplacementPlugin = require('webpack/lib/ContextReplacementPlugin');
const CopyWebpackPlugin = require('copy-webpack-plugin');
const nodeExternals = require('webpack-node-externals'); //include this

module.exports = {
	entry: {
		main: 'src/main.js',
	},
	output: {
		publicPath: '',
		filename: 'main.js',
		path: path.resolve(__dirname, 'build'),
		chunkFilename: 'static/js/[name].[chunkhash:8].chunk.js',
		libraryTarget: 'umd', //对外输出 amd模块,便于 system.js加载
		library: 'mfb-app-loader', //模块的名称
	},
	module: {
		rules: [
			{
				test: /\.js?$/,
				exclude: [path.resolve(__dirname, 'node_modules')],
				loader: 'babel-loader',
				options: {
					presets: ['stage-3', 'es2015']
				}
			}
		],
	},
	node: {
		fs: 'empty'
	},
	resolve: {
		modules: [
			__dirname,
			'node_modules',
		],
	},
	externals: [nodeExternals()], // just add this
	plugins: [
		// new webpack.DefinePlugin({
		// 	'process.env.NODE_ENV': JSON.stringify('development')
		// }),
		CopyWebpackPlugin([
			{ from: path.resolve(__dirname, 'src/index.html') },
		]),
		// new webpack.DefinePlugin({ "process.env.NODE_ENV": JSON.stringify('env') }),
		new CleanWebpackPlugin(['build'])
	],
	devtool: 'source-map',
	externals: [],
	devServer: {
		proxy: {
			'/apps.config.js': {
				// 你的测试环境地址
				target: 'http://56hub-web-staging.missfresh.net/',
			},
			'/brain': {
				// 你的测试环境地址
				target: 'http://56hub-web-staging.missfresh.net/',
			},
			'/sms': {
				// 你的测试环境地址
				target: 'http://56hub-web-staging.missfresh.net/',
			},
			'/uas': {
				// 你的测试环境地址
				target: 'http://56hub-web-staging.missfresh.net/',
			}
		}
	},
};
